#include "stdafx.h"
#include "UIC_IDirect3D9Ex.h"
#include "UIC_IDirect3DDevice9Ex.h"

UIC_IDirect3D9Ex::UIC_IDirect3D9Ex(IDirect3D9 *pOriginal, IDirect3D9Ex *pOriginalEx)
	: myOriginal(pOriginal)
	, myOriginalEx(pOriginalEx)
{
}

UIC_IDirect3D9Ex::~UIC_IDirect3D9Ex()
{
}

HRESULT __stdcall UIC_IDirect3D9Ex::QueryInterface(REFIID riid, void** ppvObj)
{
	*ppvObj = NULL;

	HRESULT hRes = myOriginal->QueryInterface(riid, ppvObj); 

	if (*ppvObj == myOriginal)
		*ppvObj = this;

	return hRes;
}

ULONG __stdcall UIC_IDirect3D9Ex::AddRef()
{
	return myOriginal->AddRef();
}

ULONG __stdcall UIC_IDirect3D9Ex::Release()
{
	ULONG count = myOriginal->Release();
	if (!count) 
		delete this; 
	return count;
}

HRESULT __stdcall UIC_IDirect3D9Ex::RegisterSoftwareDevice(void* pInitializeFunction)
{
	return myOriginal->RegisterSoftwareDevice(pInitializeFunction);
}

UINT __stdcall UIC_IDirect3D9Ex::GetAdapterCount()
{
	return myOriginal->GetAdapterCount();
}

HRESULT __stdcall UIC_IDirect3D9Ex::GetAdapterIdentifier(UINT Adapter, DWORD Flags, D3DADAPTER_IDENTIFIER9* pIdentifier)
{
	return myOriginal->GetAdapterIdentifier(Adapter, Flags, pIdentifier);
}

UINT __stdcall UIC_IDirect3D9Ex::GetAdapterModeCount(UINT Adapter, D3DFORMAT Format)
{
	return myOriginal->GetAdapterModeCount(Adapter, Format);
}

HRESULT __stdcall UIC_IDirect3D9Ex::EnumAdapterModes(UINT Adapter, D3DFORMAT Format, UINT Mode, D3DDISPLAYMODE* pMode)
{
	return myOriginal->EnumAdapterModes(Adapter, Format, Mode, pMode);
}

HRESULT __stdcall UIC_IDirect3D9Ex::GetAdapterDisplayMode(UINT Adapter, D3DDISPLAYMODE* pMode)
{
	return myOriginal->GetAdapterDisplayMode(Adapter, pMode);
}

HRESULT __stdcall UIC_IDirect3D9Ex::CheckDeviceType(UINT iAdapter, D3DDEVTYPE DevType, D3DFORMAT DisplayFormat, D3DFORMAT BackBufferFormat, BOOL bWindowed)
{
	return myOriginal->CheckDeviceType(iAdapter, DevType, DisplayFormat, BackBufferFormat, bWindowed);
}

HRESULT __stdcall UIC_IDirect3D9Ex::CheckDeviceFormat(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, DWORD Usage, D3DRESOURCETYPE RType, D3DFORMAT CheckFormat)
{
	return myOriginal->CheckDeviceFormat(Adapter, DeviceType, AdapterFormat, Usage, RType, CheckFormat);
}

HRESULT __stdcall UIC_IDirect3D9Ex::CheckDeviceMultiSampleType(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT SurfaceFormat, BOOL Windowed, D3DMULTISAMPLE_TYPE MultiSampleType, DWORD* pQualityLevels)
{
	return myOriginal->CheckDeviceMultiSampleType(Adapter, DeviceType, SurfaceFormat, Windowed, MultiSampleType, pQualityLevels);
}

HRESULT __stdcall UIC_IDirect3D9Ex::CheckDepthStencilMatch(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, D3DFORMAT RenderTargetFormat, D3DFORMAT DepthStencilFormat)
{
	return myOriginal->CheckDepthStencilMatch(Adapter, DeviceType, AdapterFormat, RenderTargetFormat, DepthStencilFormat);
}

HRESULT __stdcall UIC_IDirect3D9Ex::CheckDeviceFormatConversion(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT SourceFormat, D3DFORMAT TargetFormat)
{
	return myOriginal->CheckDeviceFormatConversion(Adapter, DeviceType, SourceFormat, TargetFormat);
}

HRESULT __stdcall UIC_IDirect3D9Ex::GetDeviceCaps(UINT Adapter, D3DDEVTYPE DeviceType, D3DCAPS9* pCaps)
{
	return myOriginal->GetDeviceCaps(Adapter, DeviceType, pCaps);
}

HMONITOR __stdcall UIC_IDirect3D9Ex::GetAdapterMonitor(UINT Adapter)
{
	return myOriginal->GetAdapterMonitor(Adapter);
}

HRESULT __stdcall UIC_IDirect3D9Ex::CreateDevice(UINT Adapter, D3DDEVTYPE DeviceType, HWND hFocusWindow, DWORD BehaviorFlags, D3DPRESENT_PARAMETERS* pPresentationParameters, IDirect3DDevice9** ppReturnedDeviceInterface)
{
	HRESULT hres = myOriginal->CreateDevice(Adapter, DeviceType, hFocusWindow, BehaviorFlags, pPresentationParameters, ppReturnedDeviceInterface);

	UIC_IDirect3DDevice9Ex *pIDirect3DDevice9 = new UIC_IDirect3DDevice9Ex(*ppReturnedDeviceInterface, NULL);
	*ppReturnedDeviceInterface = pIDirect3DDevice9;

	return hres; 
}

HRESULT __stdcall UIC_IDirect3D9Ex::CreateDeviceEx(UINT Adapter, D3DDEVTYPE DeviceType, HWND hFocusWindow, DWORD BehaviorFlags, D3DPRESENT_PARAMETERS *pPresentationParameters, D3DDISPLAYMODEEX *pFullscreenDisplayMode, IDirect3DDevice9Ex **ppReturnedDeviceInterface)
{
	// we intercept this call and provide our own "fake" Device Object
	HRESULT hres = myOriginalEx->CreateDeviceEx(Adapter, DeviceType, hFocusWindow, BehaviorFlags, pPresentationParameters, pFullscreenDisplayMode, ppReturnedDeviceInterface);

	UIC_IDirect3DDevice9Ex *pIDirect3DDevice9Ex = new UIC_IDirect3DDevice9Ex(*ppReturnedDeviceInterface, *ppReturnedDeviceInterface);

	// store our pointer (the fake one) for returning it to the calling program
	*ppReturnedDeviceInterface = pIDirect3DDevice9Ex;

	return hres;
}

HRESULT __stdcall UIC_IDirect3D9Ex::EnumAdapterModesEx(UINT Adapter, const D3DDISPLAYMODEFILTER *pFilter, UINT Mode, D3DDISPLAYMODEEX *pMode)
{
	return myOriginalEx->EnumAdapterModesEx(Adapter, pFilter, Mode, pMode);
}

HRESULT __stdcall UIC_IDirect3D9Ex::GetAdapterDisplayModeEx(UINT Adapter, D3DDISPLAYMODEEX *pMode, D3DDISPLAYROTATION *pRotation)
{
	return myOriginalEx->GetAdapterDisplayModeEx(Adapter, pMode, pRotation);
}

HRESULT __stdcall UIC_IDirect3D9Ex::GetAdapterLUID(UINT Adapter, LUID *pLUID)
{
	return myOriginalEx->GetAdapterLUID(Adapter, pLUID);
}

UINT __stdcall UIC_IDirect3D9Ex::GetAdapterModeCountEx(UINT Adapter, const D3DDISPLAYMODEFILTER *pFilter)
{
	return myOriginalEx->GetAdapterModeCountEx(Adapter, pFilter);
}
