#include "stdafx.h"
#include "UIC_IDirect3DDevice9Ex.h"
#include "UIC_IDirect3DTexture9.h"
#include "../../Launcher/UIC_SharedMemory.h"

UIC_IDirect3DDevice9Ex::UIC_IDirect3DDevice9Ex(IDirect3DDevice9* pOriginal, IDirect3DDevice9Ex* pOriginalEx)
	: myOriginalDevice(pOriginal)
	, myOriginalDeviceEx(pOriginalEx)
	, mySuppressDrawingTextureIndex(-1)
{
	UIC_IDirect3DTexture9 temp(0, 0);
	myTextureWrapperVTable = *(void**) &temp;
}

UIC_IDirect3DDevice9Ex::~UIC_IDirect3DDevice9Ex()
{
}

HRESULT UIC_IDirect3DDevice9Ex::QueryInterface(REFIID riid, void** ppvObj)
{
	HRESULT hRes = myOriginalDevice->QueryInterface(riid, ppvObj); 
	if (*ppvObj == myOriginalDevice)
		*ppvObj = this;
	return hRes;
}

ULONG UIC_IDirect3DDevice9Ex::AddRef()
{
	return myOriginalDevice->AddRef();
}

ULONG UIC_IDirect3DDevice9Ex::Release()
{
	ULONG count = myOriginalDevice->Release();
	if (!count)
		delete this;
	return count;
}

HRESULT UIC_IDirect3DDevice9Ex::TestCooperativeLevel()
{
	return myOriginalDevice->TestCooperativeLevel();
}

UINT UIC_IDirect3DDevice9Ex::GetAvailableTextureMem()
{
	return myOriginalDevice->GetAvailableTextureMem();
}

HRESULT UIC_IDirect3DDevice9Ex::EvictManagedResources()
{
	return myOriginalDevice->EvictManagedResources();
}

HRESULT UIC_IDirect3DDevice9Ex::GetDirect3D(IDirect3D9** ppD3D9)
{
	return myOriginalDevice->GetDirect3D(ppD3D9);
}

HRESULT UIC_IDirect3DDevice9Ex::GetDeviceCaps(D3DCAPS9* pCaps)
{
	return myOriginalDevice->GetDeviceCaps(pCaps);
}

HRESULT UIC_IDirect3DDevice9Ex::GetDisplayMode(UINT iSwapChain, D3DDISPLAYMODE* pMode)
{
	return myOriginalDevice->GetDisplayMode(iSwapChain, pMode);
}

HRESULT UIC_IDirect3DDevice9Ex::GetCreationParameters(D3DDEVICE_CREATION_PARAMETERS *pParameters)
{
	return myOriginalDevice->GetCreationParameters(pParameters);
}

HRESULT UIC_IDirect3DDevice9Ex::SetCursorProperties(UINT XHotSpot, UINT YHotSpot, IDirect3DSurface9* pCursorBitmap)
{
	return myOriginalDevice->SetCursorProperties(XHotSpot, YHotSpot, pCursorBitmap);
}

void UIC_IDirect3DDevice9Ex::SetCursorPosition(int X, int Y, DWORD Flags)
{
	myOriginalDevice->SetCursorPosition(X, Y, Flags);
}

BOOL UIC_IDirect3DDevice9Ex::ShowCursor(BOOL bShow)
{
	return myOriginalDevice->ShowCursor(bShow);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateAdditionalSwapChain(D3DPRESENT_PARAMETERS* pPresentationParameters, IDirect3DSwapChain9** pSwapChain)
{
	return myOriginalDevice->CreateAdditionalSwapChain(pPresentationParameters, pSwapChain);
}

HRESULT UIC_IDirect3DDevice9Ex::GetSwapChain(UINT iSwapChain, IDirect3DSwapChain9** pSwapChain)
{
	return myOriginalDevice->GetSwapChain(iSwapChain, pSwapChain);
}

UINT UIC_IDirect3DDevice9Ex::GetNumberOfSwapChains()
{
	return myOriginalDevice->GetNumberOfSwapChains();
}

HRESULT UIC_IDirect3DDevice9Ex::Reset(D3DPRESENT_PARAMETERS* pPresentationParameters)
{
	return myOriginalDevice->Reset(pPresentationParameters);
}

HRESULT UIC_IDirect3DDevice9Ex::Present(CONST RECT* pSourceRect, CONST RECT* pDestRect, HWND hDestWindowOverride, CONST RGNDATA* pDirtyRegion)
{
	myState.NewFrame();
	mySuppressDrawingTextureIndex = -1;

	return myOriginalDevice->Present(pSourceRect, pDestRect, hDestWindowOverride, pDirtyRegion);
}

HRESULT UIC_IDirect3DDevice9Ex::GetBackBuffer(UINT iSwapChain, UINT iBackBuffer, D3DBACKBUFFER_TYPE Type, IDirect3DSurface9** ppBackBuffer)
{
	return myOriginalDevice->GetBackBuffer(iSwapChain, iBackBuffer, Type, ppBackBuffer);
}

HRESULT UIC_IDirect3DDevice9Ex::GetRasterStatus(UINT iSwapChain, D3DRASTER_STATUS* pRasterStatus)
{
	return myOriginalDevice->GetRasterStatus(iSwapChain, pRasterStatus);
}

HRESULT UIC_IDirect3DDevice9Ex::SetDialogBoxMode(BOOL bEnableDialogs)
{
	return myOriginalDevice->SetDialogBoxMode(bEnableDialogs);
}

void UIC_IDirect3DDevice9Ex::SetGammaRamp(UINT iSwapChain, DWORD Flags, CONST D3DGAMMARAMP* pRamp)
{
	myOriginalDevice->SetGammaRamp(iSwapChain, Flags, pRamp);
}

void UIC_IDirect3DDevice9Ex::GetGammaRamp(UINT iSwapChain, D3DGAMMARAMP* pRamp)
{
	myOriginalDevice->GetGammaRamp(iSwapChain, pRamp);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateTexture(UINT Width, UINT Height, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DTexture9** ppTexture, HANDLE* pSharedHandle)
{
	HRESULT ret = myOriginalDevice->CreateTexture(Width, Height, Levels, Usage, Format, Pool, ppTexture, pSharedHandle);
	if (ret != D3D_OK)
		return ret;

	if (*ppTexture && myState.NeedsInit(Width, Height, Format, Levels))
	{
		UIC_IDirect3DTexture9 *texture = new UIC_IDirect3DTexture9(*ppTexture, this);
		texture->myWidth = Width;
		texture->myHeight = Height;
		texture->myLevels = Levels;
		texture->myFormat = Format;
		*ppTexture = texture;
	}

	return ret;
}

HRESULT UIC_IDirect3DDevice9Ex::CreateVolumeTexture(UINT Width, UINT Height, UINT Depth, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DVolumeTexture9** ppVolumeTexture, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateVolumeTexture(Width, Height, Depth, Levels, Usage, Format, Pool, ppVolumeTexture, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateCubeTexture(UINT EdgeLength, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DCubeTexture9** ppCubeTexture, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateCubeTexture(EdgeLength, Levels, Usage, Format, Pool, ppCubeTexture, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateVertexBuffer(UINT Length, DWORD Usage, DWORD FVF, D3DPOOL Pool, IDirect3DVertexBuffer9** ppVertexBuffer, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateVertexBuffer(Length, Usage, FVF, Pool, ppVertexBuffer, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateIndexBuffer(UINT Length, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DIndexBuffer9** ppIndexBuffer, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateIndexBuffer(Length, Usage, Format, Pool, ppIndexBuffer, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateRenderTarget(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateRenderTarget(Width, Height, Format, MultiSample, MultisampleQuality, Lockable, ppSurface, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateDepthStencilSurface(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateDepthStencilSurface(Width, Height, Format, MultiSample, MultisampleQuality, Discard, ppSurface, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::UpdateSurface(IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, IDirect3DSurface9* pDestinationSurface, CONST POINT* pDestPoint)
{
	return myOriginalDevice->UpdateSurface(pSourceSurface, pSourceRect, pDestinationSurface, pDestPoint);
}

HRESULT UIC_IDirect3DDevice9Ex::UpdateTexture(IDirect3DBaseTexture9* pSourceTexture, IDirect3DBaseTexture9* pDestinationTexture)
{
	return myOriginalDevice->UpdateTexture(pSourceTexture, pDestinationTexture);
}

HRESULT UIC_IDirect3DDevice9Ex::GetRenderTargetData(IDirect3DSurface9* pRenderTarget, IDirect3DSurface9* pDestSurface)
{
	return myOriginalDevice->GetRenderTargetData(pRenderTarget, pDestSurface);
}

HRESULT UIC_IDirect3DDevice9Ex::GetFrontBufferData(UINT iSwapChain, IDirect3DSurface9* pDestSurface)
{
	return myOriginalDevice->GetFrontBufferData(iSwapChain, pDestSurface);
}

HRESULT UIC_IDirect3DDevice9Ex::StretchRect(IDirect3DSurface9* pSourceSurface, CONST RECT* pSourceRect, IDirect3DSurface9* pDestSurface, CONST RECT* pDestRect, D3DTEXTUREFILTERTYPE Filter)
{
	return myOriginalDevice->StretchRect(pSourceSurface, pSourceRect, pDestSurface, pDestRect, Filter);
}

HRESULT UIC_IDirect3DDevice9Ex::ColorFill(IDirect3DSurface9* pSurface, CONST RECT* pRect, D3DCOLOR color)
{
	return myOriginalDevice->ColorFill(pSurface, pRect, color);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateOffscreenPlainSurface(UINT Width, UINT Height, D3DFORMAT Format, D3DPOOL Pool, IDirect3DSurface9** ppSurface, HANDLE* pSharedHandle)
{
	return myOriginalDevice->CreateOffscreenPlainSurface(Width, Height, Format, Pool, ppSurface, pSharedHandle);
}

HRESULT UIC_IDirect3DDevice9Ex::SetRenderTarget(DWORD RenderTargetIndex, IDirect3DSurface9* pRenderTarget)
{
	return myOriginalDevice->SetRenderTarget(RenderTargetIndex, pRenderTarget);
}

HRESULT UIC_IDirect3DDevice9Ex::GetRenderTarget(DWORD RenderTargetIndex, IDirect3DSurface9** ppRenderTarget)
{
	return myOriginalDevice->GetRenderTarget(RenderTargetIndex, ppRenderTarget);
}

HRESULT UIC_IDirect3DDevice9Ex::SetDepthStencilSurface(IDirect3DSurface9* pNewZStencil)
{
	return myOriginalDevice->SetDepthStencilSurface(pNewZStencil);
}

HRESULT UIC_IDirect3DDevice9Ex::GetDepthStencilSurface(IDirect3DSurface9** ppZStencilSurface)
{
	return myOriginalDevice->GetDepthStencilSurface(ppZStencilSurface);
}

HRESULT UIC_IDirect3DDevice9Ex::BeginScene()
{
	return myOriginalDevice->BeginScene();
}

HRESULT UIC_IDirect3DDevice9Ex::EndScene()
{
	return myOriginalDevice->EndScene();
}

HRESULT UIC_IDirect3DDevice9Ex::Clear(DWORD Count, CONST D3DRECT* pRects, DWORD Flags, D3DCOLOR Color, float Z, DWORD Stencil)
{
	return myOriginalDevice->Clear(Count, pRects, Flags, Color, Z, Stencil);
}

HRESULT UIC_IDirect3DDevice9Ex::SetTransform(D3DTRANSFORMSTATETYPE State, CONST D3DMATRIX* pMatrix)
{
	return myOriginalDevice->SetTransform(State, pMatrix);
}

HRESULT UIC_IDirect3DDevice9Ex::GetTransform(D3DTRANSFORMSTATETYPE State, D3DMATRIX* pMatrix)
{
	return myOriginalDevice->GetTransform(State, pMatrix);
}

HRESULT UIC_IDirect3DDevice9Ex::MultiplyTransform(D3DTRANSFORMSTATETYPE State, CONST D3DMATRIX* pMatrix)
{
	return myOriginalDevice->MultiplyTransform(State, pMatrix);
}

HRESULT UIC_IDirect3DDevice9Ex::SetViewport(CONST D3DVIEWPORT9* pViewport)
{
	return myOriginalDevice->SetViewport(pViewport);
}

HRESULT UIC_IDirect3DDevice9Ex::GetViewport(D3DVIEWPORT9* pViewport)
{
	return myOriginalDevice->GetViewport(pViewport);
}

HRESULT UIC_IDirect3DDevice9Ex::SetMaterial(CONST D3DMATERIAL9* pMaterial)
{
	return myOriginalDevice->SetMaterial(pMaterial);
}

HRESULT UIC_IDirect3DDevice9Ex::GetMaterial(D3DMATERIAL9* pMaterial)
{
	return myOriginalDevice->GetMaterial(pMaterial);
}

HRESULT UIC_IDirect3DDevice9Ex::SetLight(DWORD Index, CONST D3DLIGHT9* pLight)
{
	return myOriginalDevice->SetLight(Index, pLight);
}

HRESULT UIC_IDirect3DDevice9Ex::GetLight(DWORD Index, D3DLIGHT9* pLight)
{
	return myOriginalDevice->GetLight(Index, pLight);
}

HRESULT UIC_IDirect3DDevice9Ex::LightEnable(DWORD Index, BOOL Enable)
{
	return myOriginalDevice->LightEnable(Index, Enable);
}

HRESULT UIC_IDirect3DDevice9Ex::GetLightEnable(DWORD Index, BOOL* pEnable)
{
	return myOriginalDevice->GetLightEnable(Index, pEnable);
}

HRESULT UIC_IDirect3DDevice9Ex::SetClipPlane(DWORD Index, CONST float* pPlane)
{
	return myOriginalDevice->SetClipPlane(Index, pPlane);
}

HRESULT UIC_IDirect3DDevice9Ex::GetClipPlane(DWORD Index, float* pPlane)
{
	return myOriginalDevice->GetClipPlane(Index, pPlane);
}

HRESULT UIC_IDirect3DDevice9Ex::SetRenderState(D3DRENDERSTATETYPE State, DWORD Value)
{
	return myOriginalDevice->SetRenderState(State, Value);
}

HRESULT UIC_IDirect3DDevice9Ex::GetRenderState(D3DRENDERSTATETYPE State, DWORD* pValue)
{
	return myOriginalDevice->GetRenderState(State, pValue);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateStateBlock(D3DSTATEBLOCKTYPE Type, IDirect3DStateBlock9** ppSB)
{
	return myOriginalDevice->CreateStateBlock(Type, ppSB);
}

HRESULT UIC_IDirect3DDevice9Ex::BeginStateBlock()
{
	return myOriginalDevice->BeginStateBlock();
}

HRESULT UIC_IDirect3DDevice9Ex::EndStateBlock(IDirect3DStateBlock9** ppSB)
{
	return myOriginalDevice->EndStateBlock(ppSB);
}

HRESULT UIC_IDirect3DDevice9Ex::SetClipStatus(CONST D3DCLIPSTATUS9* pClipStatus)
{
	return myOriginalDevice->SetClipStatus(pClipStatus);
}

HRESULT UIC_IDirect3DDevice9Ex::GetClipStatus(D3DCLIPSTATUS9* pClipStatus)
{
	return myOriginalDevice->GetClipStatus(pClipStatus);
}

HRESULT UIC_IDirect3DDevice9Ex::GetTexture(DWORD Stage, IDirect3DBaseTexture9** ppTexture)
{
	return myOriginalDevice->GetTexture(Stage, ppTexture);
}

HRESULT UIC_IDirect3DDevice9Ex::SetTexture(DWORD Stage, IDirect3DBaseTexture9* pTexture)
{
	if (mySuppressDrawingTextureIndex == int(Stage))
		mySuppressDrawingTextureIndex = -1;

	if (UIC_IDirect3DTexture9* wrapper = GetWrapper(pTexture))
	{
		if (myState.Bind(wrapper))
			pTexture = wrapper->myOriginal;
		else
			pTexture = 0;

		unsigned flags = wrapper->mySuppressDrawingWhenActiveFlags;
		if ((myState.myCombinedFlagsWithTemp & UIC_SharedMemory::BlockAllRendering) && (myState.myCombinedFlagsWithTemp & UIC_SharedMemory::CombatModeWanted))
			mySuppressDrawingTextureIndex = 1000;
		else if (flags && (myState.myCombinedFlagsWithTemp & flags) == flags)
			mySuppressDrawingTextureIndex = int(Stage);

		myState.myCombinedFlagsWithTemp |= wrapper->mySetTempFlags;
		myState.myCombinedFlagsWithTemp &= ~wrapper->myClearTempFlags;
	}
	return myOriginalDevice->SetTexture(Stage, pTexture);
}

HRESULT UIC_IDirect3DDevice9Ex::GetTextureStageState(DWORD Stage, D3DTEXTURESTAGESTATETYPE Type, DWORD* pValue)
{
	return myOriginalDevice->GetTextureStageState(Stage, Type, pValue);
}

HRESULT UIC_IDirect3DDevice9Ex::SetTextureStageState(DWORD Stage, D3DTEXTURESTAGESTATETYPE Type, DWORD Value)
{
	return myOriginalDevice->SetTextureStageState(Stage, Type, Value);
}

HRESULT UIC_IDirect3DDevice9Ex::GetSamplerState(DWORD Sampler, D3DSAMPLERSTATETYPE Type, DWORD* pValue)
{
	return myOriginalDevice->GetSamplerState(Sampler, Type, pValue);
}

HRESULT UIC_IDirect3DDevice9Ex::SetSamplerState(DWORD Sampler, D3DSAMPLERSTATETYPE Type, DWORD Value)
{
	return myOriginalDevice->SetSamplerState(Sampler, Type, Value);
}

HRESULT UIC_IDirect3DDevice9Ex::ValidateDevice(DWORD* pNumPasses)
{
	return myOriginalDevice->ValidateDevice(pNumPasses);
}

HRESULT UIC_IDirect3DDevice9Ex::SetPaletteEntries(UINT PaletteNumber, CONST PALETTEENTRY* pEntries)
{
	return myOriginalDevice->SetPaletteEntries(PaletteNumber, pEntries);
}

HRESULT UIC_IDirect3DDevice9Ex::GetPaletteEntries(UINT PaletteNumber, PALETTEENTRY* pEntries)
{
	return myOriginalDevice->GetPaletteEntries(PaletteNumber, pEntries);
}

HRESULT UIC_IDirect3DDevice9Ex::SetCurrentTexturePalette(UINT PaletteNumber)
{
	return myOriginalDevice->SetCurrentTexturePalette(PaletteNumber);
}

HRESULT UIC_IDirect3DDevice9Ex::GetCurrentTexturePalette(UINT *PaletteNumber)
{
	return myOriginalDevice->GetCurrentTexturePalette(PaletteNumber);
}

HRESULT UIC_IDirect3DDevice9Ex::SetScissorRect(CONST RECT* pRect)
{
	return myOriginalDevice->SetScissorRect(pRect);
}

HRESULT UIC_IDirect3DDevice9Ex::GetScissorRect(RECT* pRect)
{
	return myOriginalDevice->GetScissorRect(pRect);
}

HRESULT UIC_IDirect3DDevice9Ex::SetSoftwareVertexProcessing(BOOL bSoftware)
{
	return myOriginalDevice->SetSoftwareVertexProcessing(bSoftware);
}

BOOL UIC_IDirect3DDevice9Ex::GetSoftwareVertexProcessing()
{
	return myOriginalDevice->GetSoftwareVertexProcessing();
}

HRESULT UIC_IDirect3DDevice9Ex::SetNPatchMode(float nSegments)
{
	return myOriginalDevice->SetNPatchMode(nSegments);
}

float	UIC_IDirect3DDevice9Ex::GetNPatchMode()
{
	return myOriginalDevice->GetNPatchMode();
}

HRESULT UIC_IDirect3DDevice9Ex::DrawPrimitive(D3DPRIMITIVETYPE PrimitiveType, UINT StartVertex, UINT PrimitiveCount)
{
	if (mySuppressDrawingTextureIndex != -1)
		return S_OK;

	return myOriginalDevice->DrawPrimitive(PrimitiveType, StartVertex, PrimitiveCount);
}

HRESULT UIC_IDirect3DDevice9Ex::DrawIndexedPrimitive(D3DPRIMITIVETYPE PrimitiveType, INT BaseVertexIndex, UINT MinVertexIndex, UINT NumVertices, UINT startIndex, UINT primCount)
{
	if (mySuppressDrawingTextureIndex != -1)
		return S_OK;

	return myOriginalDevice->DrawIndexedPrimitive(PrimitiveType, BaseVertexIndex, MinVertexIndex, NumVertices, startIndex, primCount);
}

HRESULT UIC_IDirect3DDevice9Ex::DrawPrimitiveUP(D3DPRIMITIVETYPE PrimitiveType, UINT PrimitiveCount, CONST void* pVertexStreamZeroData, UINT VertexStreamZeroStride)
{
	if (mySuppressDrawingTextureIndex != -1)
		return S_OK;

	return myOriginalDevice->DrawPrimitiveUP(PrimitiveType, PrimitiveCount, pVertexStreamZeroData, VertexStreamZeroStride);
}

HRESULT UIC_IDirect3DDevice9Ex::DrawIndexedPrimitiveUP(D3DPRIMITIVETYPE PrimitiveType, UINT MinVertexIndex, UINT NumVertices, UINT PrimitiveCount, CONST void* pIndexData, D3DFORMAT IndexDataFormat, CONST void* pVertexStreamZeroData, UINT VertexStreamZeroStride)
{
	if (mySuppressDrawingTextureIndex != -1)
		return S_OK;

	return myOriginalDevice->DrawIndexedPrimitiveUP(PrimitiveType, MinVertexIndex, NumVertices, PrimitiveCount, pIndexData, IndexDataFormat, pVertexStreamZeroData, VertexStreamZeroStride);
}

HRESULT UIC_IDirect3DDevice9Ex::ProcessVertices(UINT SrcStartIndex, UINT DestIndex, UINT VertexCount, IDirect3DVertexBuffer9* pDestBuffer, IDirect3DVertexDeclaration9* pVertexDecl, DWORD Flags)
{
	return myOriginalDevice->ProcessVertices(SrcStartIndex, DestIndex, VertexCount, pDestBuffer, pVertexDecl, Flags);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateVertexDeclaration(CONST D3DVERTEXELEMENT9* pVertexElements, IDirect3DVertexDeclaration9** ppDecl)
{
	return myOriginalDevice->CreateVertexDeclaration(pVertexElements, ppDecl);
}

HRESULT UIC_IDirect3DDevice9Ex::SetVertexDeclaration(IDirect3DVertexDeclaration9* pDecl)
{
	return myOriginalDevice->SetVertexDeclaration(pDecl);
}

HRESULT UIC_IDirect3DDevice9Ex::GetVertexDeclaration(IDirect3DVertexDeclaration9** ppDecl)
{
	return myOriginalDevice->GetVertexDeclaration(ppDecl);
}

HRESULT UIC_IDirect3DDevice9Ex::SetFVF(DWORD FVF)
{
	return myOriginalDevice->SetFVF(FVF);
}

HRESULT UIC_IDirect3DDevice9Ex::GetFVF(DWORD* pFVF)
{
	return myOriginalDevice->GetFVF(pFVF);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateVertexShader(CONST DWORD* pFunction, IDirect3DVertexShader9** ppShader)
{
	return myOriginalDevice->CreateVertexShader(pFunction, ppShader);
}

HRESULT UIC_IDirect3DDevice9Ex::SetVertexShader(IDirect3DVertexShader9* pShader)
{
	return myOriginalDevice->SetVertexShader(pShader);
}

HRESULT UIC_IDirect3DDevice9Ex::GetVertexShader(IDirect3DVertexShader9** ppShader)
{
	return myOriginalDevice->GetVertexShader(ppShader);
}

HRESULT UIC_IDirect3DDevice9Ex::SetVertexShaderConstantF(UINT StartRegister, CONST float* pConstantData, UINT Vector4fCount)
{
	return myOriginalDevice->SetVertexShaderConstantF(StartRegister, pConstantData, Vector4fCount);
}

HRESULT UIC_IDirect3DDevice9Ex::GetVertexShaderConstantF(UINT StartRegister, float* pConstantData, UINT Vector4fCount)
{
	return myOriginalDevice->GetVertexShaderConstantF(StartRegister, pConstantData, Vector4fCount);
}

HRESULT UIC_IDirect3DDevice9Ex::SetVertexShaderConstantI(UINT StartRegister, CONST int* pConstantData, UINT Vector4iCount)
{
	return myOriginalDevice->SetVertexShaderConstantI(StartRegister, pConstantData, Vector4iCount);
}

HRESULT UIC_IDirect3DDevice9Ex::GetVertexShaderConstantI(UINT StartRegister, int* pConstantData, UINT Vector4iCount)
{
	return myOriginalDevice->GetVertexShaderConstantI(StartRegister, pConstantData, Vector4iCount);
}

HRESULT UIC_IDirect3DDevice9Ex::SetVertexShaderConstantB(UINT StartRegister, CONST BOOL* pConstantData, UINT BoolCount)
{
	return myOriginalDevice->SetVertexShaderConstantB(StartRegister, pConstantData, BoolCount);
}

HRESULT UIC_IDirect3DDevice9Ex::GetVertexShaderConstantB(UINT StartRegister, BOOL* pConstantData, UINT BoolCount)
{
	return myOriginalDevice->GetVertexShaderConstantB(StartRegister, pConstantData, BoolCount);
}

HRESULT UIC_IDirect3DDevice9Ex::SetStreamSource(UINT StreamNumber, IDirect3DVertexBuffer9* pStreamData, UINT OffsetInBytes, UINT Stride)
{
	return myOriginalDevice->SetStreamSource(StreamNumber, pStreamData, OffsetInBytes, Stride);
}

HRESULT UIC_IDirect3DDevice9Ex::GetStreamSource(UINT StreamNumber, IDirect3DVertexBuffer9** ppStreamData, UINT* OffsetInBytes, UINT* pStride)
{
	return myOriginalDevice->GetStreamSource(StreamNumber, ppStreamData, OffsetInBytes, pStride);
}

HRESULT UIC_IDirect3DDevice9Ex::SetStreamSourceFreq(UINT StreamNumber, UINT Divider)
{
	return myOriginalDevice->SetStreamSourceFreq(StreamNumber, Divider);
}

HRESULT UIC_IDirect3DDevice9Ex::GetStreamSourceFreq(UINT StreamNumber, UINT* Divider)
{
	return myOriginalDevice->GetStreamSourceFreq(StreamNumber, Divider);
}

HRESULT UIC_IDirect3DDevice9Ex::SetIndices(IDirect3DIndexBuffer9* pIndexData)
{
	return myOriginalDevice->SetIndices(pIndexData);
}

HRESULT UIC_IDirect3DDevice9Ex::GetIndices(IDirect3DIndexBuffer9** ppIndexData)
{
	return myOriginalDevice->GetIndices(ppIndexData);
}

HRESULT UIC_IDirect3DDevice9Ex::CreatePixelShader(CONST DWORD* pFunction, IDirect3DPixelShader9** ppShader)
{
	return myOriginalDevice->CreatePixelShader(pFunction, ppShader);
}

HRESULT UIC_IDirect3DDevice9Ex::SetPixelShader(IDirect3DPixelShader9* pShader)
{
	return myOriginalDevice->SetPixelShader(pShader);
}

HRESULT UIC_IDirect3DDevice9Ex::GetPixelShader(IDirect3DPixelShader9** ppShader)
{
	return myOriginalDevice->GetPixelShader(ppShader);
}

HRESULT UIC_IDirect3DDevice9Ex::SetPixelShaderConstantF(UINT StartRegister, CONST float* pConstantData, UINT Vector4fCount)
{
	return myOriginalDevice->SetPixelShaderConstantF(StartRegister, pConstantData, Vector4fCount);
}

HRESULT UIC_IDirect3DDevice9Ex::GetPixelShaderConstantF(UINT StartRegister, float* pConstantData, UINT Vector4fCount)
{
	return myOriginalDevice->GetPixelShaderConstantF(StartRegister, pConstantData, Vector4fCount);
}

HRESULT UIC_IDirect3DDevice9Ex::SetPixelShaderConstantI(UINT StartRegister, CONST int* pConstantData, UINT Vector4iCount)
{
	return myOriginalDevice->SetPixelShaderConstantI(StartRegister, pConstantData, Vector4iCount);
}

HRESULT UIC_IDirect3DDevice9Ex::GetPixelShaderConstantI(UINT StartRegister, int* pConstantData, UINT Vector4iCount)
{
	return myOriginalDevice->GetPixelShaderConstantI(StartRegister, pConstantData, Vector4iCount);
}

HRESULT UIC_IDirect3DDevice9Ex::SetPixelShaderConstantB(UINT StartRegister, CONST BOOL* pConstantData, UINT BoolCount)
{
	return myOriginalDevice->SetPixelShaderConstantB(StartRegister, pConstantData, BoolCount);
}

HRESULT UIC_IDirect3DDevice9Ex::GetPixelShaderConstantB(UINT StartRegister, BOOL* pConstantData, UINT BoolCount)
{
	return myOriginalDevice->GetPixelShaderConstantB(StartRegister, pConstantData, BoolCount);
}

HRESULT UIC_IDirect3DDevice9Ex::DrawRectPatch(UINT Handle, CONST float* pNumSegs, CONST D3DRECTPATCH_INFO* pRectPatchInfo)
{
	return myOriginalDevice->DrawRectPatch(Handle, pNumSegs, pRectPatchInfo);
}

HRESULT UIC_IDirect3DDevice9Ex::DrawTriPatch(UINT Handle, CONST float* pNumSegs, CONST D3DTRIPATCH_INFO* pTriPatchInfo)
{
	return myOriginalDevice->DrawTriPatch(Handle, pNumSegs, pTriPatchInfo);
}

HRESULT UIC_IDirect3DDevice9Ex::DeletePatch(UINT Handle)
{
	return myOriginalDevice->DeletePatch(Handle);
}

HRESULT UIC_IDirect3DDevice9Ex::CreateQuery(D3DQUERYTYPE Type, IDirect3DQuery9** ppQuery)
{
	return myOriginalDevice->CreateQuery(Type, ppQuery);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::CheckDeviceState(HWND hWindow)
{
	return myOriginalDeviceEx->CheckDeviceState(hWindow);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::CheckResourceResidency(IDirect3DResource9 **ppResourceArray, UINT32 NumResources)
{
	return myOriginalDeviceEx->CheckResourceResidency(ppResourceArray, NumResources);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::ComposeRects(IDirect3DSurface9 *pSource, IDirect3DSurface9 *pDestination, IDirect3DVertexBuffer9 *pSrcRectDescriptors, UINT NumRects, IDirect3DVertexBuffer9 *pDstRectDescriptors, D3DCOMPOSERECTSOP Operation, INT XOffset, INT YOffset)
{
	return myOriginalDeviceEx->ComposeRects(pSource, pDestination, pSrcRectDescriptors, NumRects, pDstRectDescriptors, Operation, XOffset, YOffset);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::CreateDepthStencilSurfaceEx(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, IDirect3DSurface9 **ppSurface, HANDLE *pSharedHandle, DWORD Usage)
{
	return myOriginalDeviceEx->CreateDepthStencilSurfaceEx(Width, Height, Format, MultiSample, MultisampleQuality, Discard, ppSurface, pSharedHandle, Usage);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::CreateOffscreenPlainSurfaceEx(UINT Width, UINT Height, D3DFORMAT Format, D3DPOOL Pool, IDirect3DSurface9 **ppSurface, HANDLE *pSharedHandle, DWORD Usage)
{
	return myOriginalDeviceEx->CreateOffscreenPlainSurfaceEx(Width, Height, Format, Pool, ppSurface, pSharedHandle, Usage);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::CreateRenderTargetEx(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, IDirect3DSurface9 **ppSurface, HANDLE *pSharedHandle, DWORD Usage)
{
	return myOriginalDeviceEx->CreateRenderTargetEx(Width, Height, Format, MultiSample, MultisampleQuality, Lockable, ppSurface, pSharedHandle, Usage);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::GetDisplayModeEx(UINT iSwapChain, D3DDISPLAYMODEEX *pMode, D3DDISPLAYROTATION *pRotation)
{
	return myOriginalDeviceEx->GetDisplayModeEx(iSwapChain, pMode, pRotation);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::GetGPUThreadPriority(INT *pPriority)
{
	return myOriginalDeviceEx->GetGPUThreadPriority(pPriority);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::GetMaximumFrameLatency(UINT *pMaxLatency)
{
	return myOriginalDeviceEx->GetMaximumFrameLatency(pMaxLatency);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::PresentEx(const RECT *pSourceRect, const RECT *pDestRect, HWND hDestWindowOverride, const RGNDATA *pDirtyRegion, DWORD dwFlags)
{
	return myOriginalDeviceEx->PresentEx(pSourceRect, pDestRect, hDestWindowOverride, pDirtyRegion, dwFlags);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::ResetEx(D3DPRESENT_PARAMETERS *pPresentationParameters, D3DDISPLAYMODEEX *pFullscreenDisplayMode)
{
	return myOriginalDeviceEx->ResetEx(pPresentationParameters, pFullscreenDisplayMode);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::SetConvolutionMonoKernel(UINT Width, UINT Height, float *RowWeights, float *ColumnWeights)
{
	return myOriginalDeviceEx->SetConvolutionMonoKernel(Width, Height, RowWeights, ColumnWeights);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::SetGPUThreadPriority(INT pPriority)
{
	return myOriginalDeviceEx->SetGPUThreadPriority(pPriority);
}

HRESULT __stdcall UIC_IDirect3DDevice9Ex::SetMaximumFrameLatency(UINT pMaxLatency)
{
	return myOriginalDeviceEx->SetMaximumFrameLatency(pMaxLatency);
}

/*
HRESULT __stdcall UIC_IDirect3DDevice9Ex::TestCooperativeLevel()
{
return myOriginalDeviceEx->TestCooperativeLevel();
}
*/

HRESULT __stdcall UIC_IDirect3DDevice9Ex::WaitForVBlank(UINT SwapChainIndex)
{
	return myOriginalDeviceEx->WaitForVBlank(SwapChainIndex);
}
