#pragma once

#include <vector>

class UIC_IDirect3DDevice9Ex;

class UIC_IDirect3DTexture9 : public IDirect3DTexture9
{
public:
	UIC_IDirect3DTexture9(IDirect3DTexture9 *pTex, UIC_IDirect3DDevice9Ex* pDevice);
	~UIC_IDirect3DTexture9();

	STDMETHOD(QueryInterface) (REFIID riid, void** ppvObj);
	STDMETHOD_(ULONG, AddRef)();
	STDMETHOD_(ULONG, Release)();
	STDMETHOD(GetDevice)(IDirect3DDevice9** ppDevice);
	STDMETHOD(SetPrivateData)(REFGUID refguid, CONST void* pData, DWORD SizeOfData, DWORD Flags);
	STDMETHOD(GetPrivateData)(REFGUID refguid, void* pData, DWORD* pSizeOfData);
	STDMETHOD(FreePrivateData)(REFGUID refguid);
	STDMETHOD_(DWORD, SetPriority)(DWORD PriorityNew);
	STDMETHOD_(DWORD, GetPriority)();
	STDMETHOD_(void, PreLoad)();
	STDMETHOD_(D3DRESOURCETYPE, GetType)();
	STDMETHOD_(DWORD, SetLOD)(DWORD LODNew);
	STDMETHOD_(DWORD, GetLOD)();
	STDMETHOD_(DWORD, GetLevelCount)();
	STDMETHOD(SetAutoGenFilterType)(D3DTEXTUREFILTERTYPE FilterType);
	STDMETHOD_(D3DTEXTUREFILTERTYPE, GetAutoGenFilterType)();
	STDMETHOD_(void, GenerateMipSubLevels)();
	STDMETHOD(GetLevelDesc)(UINT Level, D3DSURFACE_DESC *pDesc);
	STDMETHOD(GetSurfaceLevel)(UINT Level, IDirect3DSurface9** ppSurfaceLevel);
	STDMETHOD(LockRect)(UINT Level, D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD Flags);
	STDMETHOD(UnlockRect)(UINT Level);
	STDMETHOD(AddDirtyRect)(CONST RECT* pDirtyRect);

public:
	IDirect3DTexture9 *myOriginal;
	UIC_IDirect3DDevice9Ex* myDevice;

	unsigned myLastBindFrame;
	unsigned myLastBindCounter;
	unsigned mySetOnBindFlags;
	unsigned mySuppressDrawingWhenActiveFlags;
	unsigned mySetTempFlags;
	unsigned myClearTempFlags;

	bool myIsInitialized;
	bool myIsLockedForInit;
	bool myIsAddedToList;
	D3DLOCKED_RECT myLockedRect;

	unsigned myWidth;
	unsigned myHeight;
	unsigned myLevels;
	unsigned myFormat;
	unsigned myCRC32;
};
