#pragma once

#include <mutex>
#include <vector>

class UIC_IDirect3DTexture9;
struct UIC_SharedMemory;

class UIC_StateTracker
{
public:
	UIC_StateTracker();
	~UIC_StateTracker();

	bool NeedsInit(unsigned aWidth, unsigned aHeight, unsigned aFormat, unsigned aLevels);

	void AddTexture(UIC_IDirect3DTexture9* aTexture);
	void RemoveTexture(UIC_IDirect3DTexture9* aTexture);

	bool Bind(UIC_IDirect3DTexture9* aTexture);
	void NewFrame();

	unsigned myCombinedFlagsWithTemp;

private:
	bool StepSelection(int aDelta);
	bool SelectLast();
	bool SaveSelected();

	UIC_SharedMemory* mySharedMemory;
	unsigned myFrameCounter;
	unsigned myTextureBindCounter;
	unsigned myLastFrameFlags;
	unsigned myCurrentFrameFlags;
	bool myIsDevMode;

	std::mutex myTexturesMutex;
	std::vector<UIC_IDirect3DTexture9*> myTextures;
	UIC_IDirect3DTexture9* myCurrentSelection;
};
