#include "stdafx.h"
#include "d3d9_dll.h"
#include "Interfaces/UIC_IDirect3D9Ex.h"

HINSTANCE g_D3D9DLL_Actual = NULL;

typedef IDirect3D9 *(APIENTRY *Direct3DCreate9_type)(UINT);
typedef HRESULT (APIENTRY *Direct3DCreate9Ex_type)(UINT SDKVersion, IDirect3D9Ex **ppD3D);

static Direct3DCreate9_type locDirect3DCreate9 = NULL;
static Direct3DCreate9Ex_type locDirect3DCreate9Ex = NULL;

void UIC_D3D9DLL_Init()
{
	UIC_D3D9DLL_LoadOriginal();

	if (g_D3D9DLL_Actual)
	{
		locDirect3DCreate9 = (Direct3DCreate9_type) GetProcAddress(g_D3D9DLL_Actual, "Direct3DCreate9");
		if (locDirect3DCreate9)
			locDirect3DCreate9 = (Direct3DCreate9_type) DetourFunc((BYTE*) locDirect3DCreate9, (BYTE*) UIC_D3D9DLL_Direct3DCreate9, 5);

		locDirect3DCreate9Ex = (Direct3DCreate9Ex_type) GetProcAddress(g_D3D9DLL_Actual, "Direct3DCreate9Ex");
		if (locDirect3DCreate9Ex)
			locDirect3DCreate9Ex = (Direct3DCreate9Ex_type) DetourFunc((BYTE*) locDirect3DCreate9Ex, (BYTE*) UIC_D3D9DLL_Direct3DCreate9Ex, 7);
	}
}

void UIC_D3D9DLL_Exit()
{
	if (g_D3D9DLL_Actual)
	{
		FreeLibrary(g_D3D9DLL_Actual);
		g_D3D9DLL_Actual = 0;
	}
}

void UIC_D3D9DLL_LoadOriginal()
{
	if (g_D3D9DLL_Actual)
		return;

	g_D3D9DLL_Actual = LoadLibraryA("d3d9.dll");
}


IDirect3D9 *APIENTRY UIC_D3D9DLL_Direct3DCreate9(UINT SDKVersion)
{
	RetourFunc((BYTE*) GetProcAddress(g_D3D9DLL_Actual, "Direct3DCreate9"), (BYTE*) locDirect3DCreate9, 5);
	locDirect3DCreate9 = (Direct3DCreate9_type) GetProcAddress(g_D3D9DLL_Actual, "Direct3DCreate9");

	IDirect3D9 *d3d = locDirect3DCreate9(SDKVersion);

	locDirect3DCreate9 = (Direct3DCreate9_type) DetourFunc((BYTE*) locDirect3DCreate9, (BYTE*) UIC_D3D9DLL_Direct3DCreate9, 5);

	return new UIC_IDirect3D9Ex(d3d, 0);
}

HRESULT APIENTRY UIC_D3D9DLL_Direct3DCreate9Ex(UINT SDKVersion, IDirect3D9Ex **ppD3D)
{
	RetourFunc((BYTE*) GetProcAddress(g_D3D9DLL_Actual, "Direct3DCreate9Ex"), (BYTE*) locDirect3DCreate9Ex, 7);
	locDirect3DCreate9Ex = (Direct3DCreate9Ex_type) GetProcAddress(g_D3D9DLL_Actual, "Direct3DCreate9Ex");

	HRESULT ret = locDirect3DCreate9Ex(SDKVersion, ppD3D);

	locDirect3DCreate9Ex = (Direct3DCreate9Ex_type) DetourFunc((BYTE*) locDirect3DCreate9Ex, (BYTE*) UIC_D3D9DLL_Direct3DCreate9Ex, 7);

	*ppD3D = new UIC_IDirect3D9Ex(*ppD3D, *ppD3D);

	return ret;
}
